mod editor;
mod helpers;

use crate::editor::Editor;
use crate::helpers::*;

fn main() {
    // Save original terminal flags
    let original_termios = get_termios(STDIN_FILENO);

    // Disable canonical/"cooked" terminal mode
    enable_raw_mode();

    // Initialize the editor
    let mut editor = Editor::new();

    // Main input loop. Editor::process_keypress uses an Option Enum as a sentinel.
    // `None` is returned on a quit action, in other cases, `Some(())` is returned,
    // continuing the loop
    while editor.process_keypress().is_some() {
        // loop
    }

    // Restore previous terminal flags before exit
    disable_raw_mode(&original_termios);
}
